/*
  *  
  *	see tcpha_be.c for infoes about TCPHA
  *
  */
  
#ifndef _TCPHA_BE_CON_H
#define _TCPHA_BE_CON_H

struct tcpha_be_conn *
tcpha_be_conn_create(struct socket *, struct tcpha_be_service *);
int
tcpha_be_conn_handle(struct tcpha_be_conn *, struct tcpha_be_service *);
int 
tcpha_be_adv_conn_handle(struct tcpha_be_service *,char *,int);
const char * tcpha_be_state_name(int);
int tcpha_be_set_state_timeout(struct tcpha_be_client_conn *, int);
void tcpha_be_conn_expire_now(struct tcpha_be_client_conn *);
void
tcpha_be_conn_release(struct tcpha_be_conn *);
static inline void __tcpha_be_conn_put(struct tcpha_be_client_conn *cp)
{
	atomic_dec(&cp->refcnt);
}

/*
 *      Put back the conn and restart its timer with its timeout,called by bh
 */
static inline void tcpha_be_conn_put(struct tcpha_be_client_conn *cp)
{
	/* reset it expire in its timeout */
	mod_timer(&cp->timer, jiffies+cp->timeout);

	__tcpha_be_conn_put(cp);
}

#endif
