/*
  *  
  *	see tcpha_be.c for infoes about TCPHA
  *
  */

#ifndef _TCPHA_BE_FILE_H
#define _TCPHA_BE_FILE_H

#define DEFCONFIGFILE                         "/etc/tcpha/tcphabe.conf"

struct config_file {
	char *name;
	char *line;
	struct file *fd;
	char *position;
	char *lineEnd;
	int lineNum;
	char *token;
};

#define TCPHA_BE_MAX_DAEMONS		128

#ifndef strdup
static __inline__ char *
strdup(const char *str)
{
	int n = strlen(str) + 1;
	char *s = kmalloc(n, GFP_ATOMIC);
	if (!s)
		return NULL;
	return strcpy(s, str);
}
#endif

#ifndef strcasecmp
static __inline__ int
strcasecmp(const char *s1,const char *s2)
{
	int len=strlen(s1),i,j='A'-'a';
	
	if (len!=strlen(s2))
		goto out_error;
	for (i=0;i<len;i++) {
		if (s1[i]!=s2[i]) {
			if (('a'<=s1[i])&&(s1[i]<='z')&&(s2[i]-s1[i]==j))
				continue;
			if (('A'<=s1[i])&&(s1[i]<='Z')&&(s1[i]-s2[i]==j))
				continue;
			break;
		}
	}
	if (i<len)
	     goto out_error;
	return 0;
	out_error:
	return -1;
}
#endif

static inline int
isavalidip(const char *str,__u32 *addr)
{
	int len=strlen(str),i,j=0;
	unsigned long l=0;
	unsigned int val;

	for (i=0;i<len;i++) {
		if (str[i]>'9'||str[i]<'0') {
			if (str[i]!='.')
				break;
			else {
				j++;
				continue;
			}
		}
	}
	if (i<len||j!=3)
		goto out_error;
	l = 0;
	for (i = 0; i < 4; i++) {
		l <<= 8;
		if (*str != '\0') {
			val = 0;
			while (*str != '\0' && *str != '.') {
				val *= 10;
				val += *str - '0';
				str++;
			}
			if (val > 255)
				goto out_error;
			l |= val;
			if (*str != '\0')
				str++;
		}
	}
	*addr=htonl(l);
	return 0;
      out_error:
	return -1;
}

int get_next_token(struct config_file *, int *);
int config_tcpha_be(struct  tcpha_be_service *);
struct config_file *open_configfile(const char *);
void close_configfile(struct config_file *);

#endif
