/*
  *  
  *	see tcpha_be.c for infoes about TCPHA
  *
  */
  
#include "tcpha_be.h"

static void
dummy_destructor(struct open_request *req)
{
}

static struct or_calltable dummy = {
	0,
	NULL,
	NULL,
	&dummy_destructor,
	NULL
};

struct sock *fake_connection(struct sock *,struct sock *,struct tcpha_conn_info *);
int trans_pkt(struct sock *, struct sock *,struct sk_buff *skb);

int
redirect_to_local(struct tcpha_be_conn *conn,struct tcpha_conn_info *info,struct sk_buff *skb, __u32 addr, __u16 port)
{
	struct socket *sock;
	struct open_request *tcpreq;
	struct sock *sk, *nsk,*csk;
	int rc = 0;

	sock = conn->fsock;

	/* search for local listening user-space socket */
	local_bh_disable();
	sk = tcp_v4_lookup_listener(addr, ntohs(port), 0);
	local_bh_enable();

	/* No socket found */
	if (!sk) {
		ERR("no server found\n");
		rc = -1;
		goto out;
	}

	csk = sock->sk;
	nsk=fake_connection(sk,csk,info);
	if (!nsk) {
		rc=-1;
		goto out;
	}
	int len=trans_pkt(csk,nsk,skb);
	if (len>0)
		DBG("transed packet:%d\n",len);
	else {
		rc=-1;
		goto out;
	}
	
	lock_sock(sk);

	if (sk->state != TCP_LISTEN) {
		rc = -1;
		goto out_unlock;
	}

	tcpreq = tcp_openreq_alloc();
	if (!tcpreq) {
		rc = -1;
		goto out_unlock;
	}

	tcpreq->class = &dummy;
	
	tcp_acceptq_queue(sk, tcpreq, nsk);	
	sk->tp_pinfo.af_tcp.nonagle = 0;
	sk->data_ready(sk, len);

      out_unlock:
	release_sock(sk);
	sock_put(sk);
      out:
	return rc;
}

