/*
  *  
  *	see tcpha_fe.c for infoes about TCPHA
  *
  */

#ifndef _TCPHA_FE_CON_H
#define _TCPHA_FE_CON_H

struct tcpha_fe_conn *tcpha_fe_conn_in_get
(__u32, __u16, __u32, __u16);
struct tcpha_fe_conn *tcpha_fe_conn_out_get
(__u32, __u16, __u32, __u16);
const char * tcpha_fe_state_name(int);
struct tcpha_control_conn *tcpha_fe_new_ctrlconn(struct tcpha_be *);
struct tcpha_fe_conn *
tcpha_fe_conn_create(struct socket *,struct tcpha_fe_service *, char *, size_t);
void tcpha_fe_close_ctrlconn(struct tcpha_control_conn *);
int 
tcpha_fe_adv_conn_handle(struct tcpha_fe_service *,struct socket *,struct tcpha_fe_info *);
int
tcpha_fe_conn_handle(struct tcpha_fe_conn *, struct tcpha_fe_service *);
int tcpha_fe_set_state_timeout(struct tcpha_fe_conn *, int);
void tcpha_fe_conn_expire_now(struct tcpha_fe_conn *);
void
tcpha_fe_conn_reset(struct tcpha_fe_conn *);
void
tcpha_fe_conn_release(struct tcpha_fe_conn *);
void tcpha_fe_conn_release_now(struct tcpha_fe_conn *);
static inline void __tcpha_fe_conn_put(struct tcpha_fe_conn *cp)
{
	atomic_dec(&cp->refcnt);
}

/*
 *      Put back the conn and restart its timer with its timeout,called by bh
 */
static inline void tcpha_fe_conn_put(struct tcpha_fe_conn *cp)
{
	/* reset it expire in its timeout */
	mod_timer(&cp->timer, jiffies+cp->timeout);

	__tcpha_fe_conn_put(cp);
}

#endif
