/*
  *  
  *	see tcpha_fe.c for infoes about TCPHA
  *
  */
  
#include "tcpha_fe.h"

static void
dummy_destructor(struct open_request *req)
{
}

static struct or_calltable dummy = {
	0,
	NULL,
	NULL,
	&dummy_destructor,
	NULL
};


int
redirect_to_local(struct tcpha_fe_conn *conn, __u32 addr, __u16 port)
{
	struct socket *sock;
	struct open_request *tcpreq;
	struct sock *sk, *oldsk;
	int rc = 0;

	sock = conn->csock;

	/* search for local listening user-space socket */
	local_bh_disable();
	sk = tcp_v4_lookup_listener(addr, ntohs(port), 0);
	local_bh_enable();

	/* No socket found */
	if (!sk) {
		ERR_RL("no server found\n");
		rc = -1;
		goto out;
	}

	oldsk = sock->sk;
	lock_sock(sk);

	if (sk->state != TCP_LISTEN) {
		rc = -1;
		goto out_unlock;
	}

	tcpreq = tcp_openreq_alloc();
	if (!tcpreq) {
		rc = -1;
		goto out_unlock;
	}

	sock->sk = NULL;
	sock->state = SS_UNCONNECTED;

	tcpreq->class = &dummy;
	write_lock_irq(&oldsk->callback_lock);
	oldsk->socket = NULL;
	oldsk->sleep = NULL;
	write_unlock_irq(&oldsk->callback_lock);

	tcp_acceptq_queue(sk, tcpreq, oldsk);

	sk->tp_pinfo.af_tcp.nonagle = 0;
	sk->data_ready(sk, 0);

      out_unlock:
	release_sock(sk);
	sock_put(sk);
      out:
	return rc;
}

